summaryrefslogtreecommitdiff
path: root/etc
diff options
context:
space:
mode:
authorJoseph Hunkeler <jhunkeler@gmail.com>2019-01-31 14:24:24 -0500
committerJoseph Hunkeler <jhunkeler@gmail.com>2019-01-31 14:24:24 -0500
commit30ea4ba9222c0d9b24bf401639eddef4e5b9ef89 (patch)
tree13ee9f133b6cc3fc6b6ce6aeef48d1347e125569 /etc
downloaddocker-pipeline-nb-30ea4ba9222c0d9b24bf401639eddef4e5b9ef89.tar.gz
Initial commit
Diffstat (limited to 'etc')
-rw-r--r--etc/pip/000-dummy0
-rwxr-xr-xetc/pkgs/000-dummy.sh2
-rwxr-xr-xetc/pkgs/001-tini.sh18
-rwxr-xr-xetc/pkgs/002-nodejs.sh17
-rwxr-xr-xetc/pkgs/003-jupyter.sh15
-rwxr-xr-xetc/tasks/001-packages.sh41
-rwxr-xr-xetc/tasks/002-python-packages.sh38
-rwxr-xr-xetc/tasks/999-clean.sh17
8 files changed, 148 insertions, 0 deletions
diff --git a/etc/pip/000-dummy b/etc/pip/000-dummy
new file mode 100644
index 0000000..e69de29
--- /dev/null
+++ b/etc/pip/000-dummy
diff --git a/etc/pkgs/000-dummy.sh b/etc/pkgs/000-dummy.sh
new file mode 100755
index 0000000..06bd986
--- /dev/null
+++ b/etc/pkgs/000-dummy.sh
@@ -0,0 +1,2 @@
+#!/bin/bash
+exit 0
diff --git a/etc/pkgs/001-tini.sh b/etc/pkgs/001-tini.sh
new file mode 100755
index 0000000..44bb172
--- /dev/null
+++ b/etc/pkgs/001-tini.sh
@@ -0,0 +1,18 @@
+#!/bin/bash
+set -x
+
+sudo yum install -y cmake glibc-static || exit 1
+git clone https://github.com/krallin/tini.git
+export CFLAGS="${CFLAGS} -DPR_SET_CHILD_SUBREAPER=36 -DPR_GET_CHILD_SUBREAPER=37"
+
+pushd tini
+ git checkout v0.18.0
+ mkdir -p build
+ pushd build
+ cmake ..
+ make
+ install -m755 tini ${TOOLCHAIN_BIN}
+ popd
+popd
+
+rm -rf tini
diff --git a/etc/pkgs/002-nodejs.sh b/etc/pkgs/002-nodejs.sh
new file mode 100755
index 0000000..b52a229
--- /dev/null
+++ b/etc/pkgs/002-nodejs.sh
@@ -0,0 +1,17 @@
+#!/bin/bash
+set -x
+
+name=node
+version=v10.15.0
+srcdir=${name}-${version}
+tarball=${srcdir}.tar.gz
+url=https://nodejs.org/dist/${version}/${tarball}
+
+curl -LO "${url}"
+tar xf "${tarball}"
+pushd "${srcdir}"
+ export CFLAGS="${CFLAGS} -fPIC"
+ ./configure --prefix=${TOOLCHAIN}
+ make -j${_maxjobs}
+ make install
+popd
diff --git a/etc/pkgs/003-jupyter.sh b/etc/pkgs/003-jupyter.sh
new file mode 100755
index 0000000..dfc312a
--- /dev/null
+++ b/etc/pkgs/003-jupyter.sh
@@ -0,0 +1,15 @@
+#!/bin/bash
+set -x
+
+pip install --upgrade --progress-bar=off \
+ notebook==5.7.2 \
+ jupyterhub==0.9.4 \
+ jupyterlab==0.35.4
+
+jupyter labextension install @jupyterlab/hub-extension@^0.12.0
+jupyter notebook --generate-config -y
+
+# Clean up
+npm cache clean --force
+rm -rf ${TOOLCHAIN}/share/jupyter/lab/staging
+rm -rf /home/${USER_ACCT}/.cache/yarn
diff --git a/etc/tasks/001-packages.sh b/etc/tasks/001-packages.sh
new file mode 100755
index 0000000..5d20ee7
--- /dev/null
+++ b/etc/tasks/001-packages.sh
@@ -0,0 +1,41 @@
+#!/bin/bash
+set -x
+
+sysconfdir="${TOOLCHAIN_BUILD}/etc"
+reqdir=${sysconfdir}/pkgs
+blddir=builds
+
+function pre()
+{
+ if [[ ! -d ${reqdir} ]]; then
+ # Nothing there, but maybe that's on purpose.
+ exit 0
+ fi
+ mkdir -p "${blddir}"
+ pushd ${blddir} &>/dev/null
+}
+
+function build()
+{
+ pre
+ # Iterate over binary package build scripts
+ for req in ${reqdir}/*
+ do
+ chmod +x "${req}"
+ "${req}"
+ retval=$?
+ if [[ ${retval} != 0 ]]; then
+ echo "BUILD FAILED: ${req}"
+ exit ${retval}
+ fi
+ done
+ post
+}
+
+function post()
+{
+ popd &>/dev/null
+ [[ -d ${blddir} ]] && rm -rf "${blddir}"
+}
+
+build
diff --git a/etc/tasks/002-python-packages.sh b/etc/tasks/002-python-packages.sh
new file mode 100755
index 0000000..bcd0b6f
--- /dev/null
+++ b/etc/tasks/002-python-packages.sh
@@ -0,0 +1,38 @@
+#!/bin/bash
+set -x
+
+sysconfdir="${TOOLCHAIN_BUILD}/etc"
+reqdir=${sysconfdir}/pip
+
+function pre()
+{
+ if [[ ! -d ${reqdir} ]]; then
+ # Nothing there, but maybe that's on purpose.
+ exit 0
+ fi
+}
+
+function build()
+{
+ pre
+ # Iterate over pip requirement files
+ for req in ${reqdir}/*
+ do
+ pip install --upgrade --progress-bar=off -r "${req}"
+ retval=$?
+ if [[ ${retval} != 0 ]]; then
+ echo "BUILD FAILED: ${req}"
+ exit ${retval}
+ fi
+ done
+ post
+}
+
+function post()
+{
+ rm -rf ~/.cache/pip
+ [[ -d src ]] && rm -rf src || true
+ [[ -f gmon.out ]] && rm -rf gmon.out || true
+}
+
+build
diff --git a/etc/tasks/999-clean.sh b/etc/tasks/999-clean.sh
new file mode 100755
index 0000000..44f5d16
--- /dev/null
+++ b/etc/tasks/999-clean.sh
@@ -0,0 +1,17 @@
+#!/bin/bash
+if [[ ! -f /.dockerenv ]]; then
+ echo "This script cannot be executed outside of a docker container."
+ exit 1
+fi
+
+sudo yum clean all
+
+sudo rm -rf "${HOME}/.astropy"
+sudo rm -rf "${HOME}"/*
+sudo rm -rf /tmp/*
+sudo rm -rf /var/cache/yum
+
+for logfile in /var/log/*
+do
+ [[ -f ${logfile} ]] && sudo truncate --size=0 "${logfile}"
+done